import { chainEnv, pureEnv, resumeNow } from './env';
export const co = (f) => (...args) => ({
    [Symbol.iterator]() { return f(...args); }
});
export const op = (env) => ({
    *[Symbol.iterator]() { return yield env; }
});
export const runComputation = (g) => {
    const i = startComputation(g);
    return stepComputation(i, i.next());
};
const stepComputation = (i, ir) => ir.done ? pureEnv(ir.value) : chainEnv(ir.value, n => stepComputation(i, i.next(n)));
export const startComputation = (c) => c[Symbol.iterator]();
export const get = () => op(resumeNow);
export const use = (cg, c) => op((c0) => runComputation(cg)({ ...c0, ...c }));
export const embed = (cg, f) => op((c) => runComputation(cg)(f(c)));
//# sourceMappingURL=computation.js.map